# Are we pruning the correct channels in image-to-image translation models? （BIGP）

[![License: MIT](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/licenses/MIT)



## Visualization Results
Image-to-image translation by (compressed) CycleGAN:
![](results.PNG)

## Training
### 1. Download dataset:
```
./download_dataset <dataset_name>
```
This will download the dataset to folder `datasets/<dataset_name>` (e.g., `datasets/summer2winter_yosemite`).

### 2. Get the original dense CycleGAN:
#### summer2winter_yosemite dataset
Use the [official CycleGAN codes](https://github.com/junyanz/pytorch-CycleGAN-and-pix2pix) to train original dense CycleGAN.
and load their parameter in our model

#### horse2zebra dataset
Use the [official CycleGAN codes](https://github.com/junyanz/pytorch-CycleGAN-and-pix2pix) to train original dense CycleGAN.
and load their parameter in our model

### 3. Generate style transfer results on training set
Use the pretrained dense generator to generate style transfer results on training set and put the style transfer results to folder `train_set_result/<dataset_name>`.
For example, `train_set_result/summer2winter_yosemite/B/2009-12-06 06:58:39_fake.png` is the fake winter image transferred from the real summer image `datasets/summer2winter_yosemite/A/2009-12-06 06:58:39.png` using the original dense CycleGAN.

### 4. Train and Compress
code eg:
```
python gs_tsp.py --alpha 0.0000124 --contral_rate 0.0125 --epochs 600 --dataset horse2zebra --task A2B --gpu 0 --name example
```
The training results (checkpoints, loss curves, etc.) will be saved in `results/<dataset_name>/<task_name>`.



### 5. Extract compact subnetwork obtained by GS
We already updated the weight and bias of IN to 0. So it's easy to extract the subnet model.

```
python extract_subnet.py --dataset <dataset_name> --task <task_name> --model_str <model_str> 
```

The extracted subnetworks will be saved in `subnet_structures/<dataset_name>/<task_name>`

### 6. Finetune subnetwork
```
python finetune.py --dataset <dataset_name> --task <task_name> --base_model_str <base_model_str>
```

